﻿local L = LibStub:GetLibrary( "AceLocale-3.0" ):GetLocale( "Broker_Mail")
local Mail = CreateFrame("Frame", "Broker_Mail")

Mail.obj = LibStub("LibDataBroker-1.1"):NewDataObject(L["Broker_Mail"], {type = "data source", icon = "Interface\\AddOns\\Broker_Mail\\nomail", label = L["Mailbox"]})

local L_NEW = L["New Mail"]
local L_NONE = L["No Mail"]

Mail:RegisterEvent("UPDATE_PENDING_MAIL")
Mail:RegisterEvent("MAIL_INBOX_UPDATE")
Mail:RegisterEvent("PLAYER_LOGIN")
Mail:SetScript("OnEvent", function()
	if HasNewMail() then
		Mail.obj.icon = "Interface\\AddOns\\Broker_Mail\\newmail"
		Mail.obj.text = L_NEW
	else
		Mail.obj.icon = "Interface\\AddOns\\Broker_Mail\\nomail"
		Mail.obj.text = L_NONE
	end
end)

function Mail.obj.OnTooltipShow(tip)
	if not tip or not tip.AddLine then return end

	local a, b, c = GetLatestThreeSenders()
	tip:AddLine(_G["HAVE_MAIL_FROM"])
	if a then tip:AddLine(a) end
	if b then tip:AddLine(b) end
	if c then tip:AddLine(c) end
end

MiniMapMailFrame:UnregisterAllEvents()
MiniMapMailFrame:Hide()
