local addon = LibStub('AceAddon-3.0'):GetAddon('KuiNameplates')
local kui = LibStub('Kui-1.0')

------------------------------------------------------------------ Background --
function addon:CreateBackground(frame, f)
	-- frame glow
	--f.bg:SetParent(f.parent)
	f.bg = f:CreateTexture(nil, 'ARTWORK')
	f.bg:SetTexture('Interface\\AddOns\\Kui_Nameplates\\media\\FrameGlow')
	f.bg:SetTexCoord(0, .469, 0, .625)
	f.bg:SetVertexColor(0, 0, 0, .9)

	-- solid background
	f.bg.fill = f.parent:CreateTexture(nil, 'BACKGROUND')
	f.bg.fill:SetTexture(kui.m.t.solid)
	f.bg.fill:SetVertexColor(0, 0, 0, .8)
	f.bg.fill:SetDrawLayer('ARTWORK', 1) -- 1 sub-layer above .bg

	f.bg.fill:SetSize(self.sizes.frame.width, self.sizes.frame.height)
	f.bg.fill:SetPoint('BOTTOMLEFT', f.x, f.y)

	f.bg:SetPoint('BOTTOMLEFT', f.bg.fill, 'BOTTOMLEFT',
		-self.sizes.frame.bgOffset,
		-self.sizes.frame.bgOffset)
	f.bg:SetPoint('TOPRIGHT', f.bg.fill, 'TOPRIGHT',
		self.sizes.frame.bgOffset,
		self.sizes.frame.bgOffset)
end
------------------------------------------------------------------ Health bar --
function addon:CreateHealthBar(frame, f)
	f.health = CreateFrame('StatusBar', nil, f.parent)
	f.health:SetStatusBarTexture(kui.m.t.bar)

	f.health:ClearAllPoints()
	f.health:SetSize(self.sizes.frame.width-2, self.sizes.frame.height-2)
	f.health:SetPoint('BOTTOMLEFT', f.x+1, f.y+1)

	if self.SetValueSmooth then
		-- smooth bar
		f.health.OrigSetValue = f.health.SetValue
		f.health.SetValue = self.SetValueSmooth
	end
end
------------------------------------------------------------------- Highlight --
function addon:CreateHighlight(frame, f)
	if not self.db.profile.general.highlight then return end

	f.highlight = f.overlay:CreateTexture(nil, 'ARTWORK')
	f.highlight:SetTexture(kui.m.t.bar)
	f.highlight:SetAllPoints(f.health)

	f.highlight:SetVertexColor(1, 1, 1)
	f.highlight:SetBlendMode('ADD')
	f.highlight:SetAlpha(.4)
	f.highlight:Hide()
end
----------------------------------------------------------------- Health text --
function addon:CreateHealthText(frame, f)
	f.health.p = f:CreateFontString(f.overlay, {
		font = self.font, size = 'large', outline = "OUTLINE" })
	f.health.p:SetJustifyH('RIGHT')
	f.health.p:SetJustifyV('BOTTOM')
	f.health.p:SetHeight(10)
	f.health.p:SetPoint('BOTTOMRIGHT', f.health, 'TOPRIGHT',
		-2.5, self.uiscale and -(2.5/self.uiscale) or -2.5)
end
------------------------------------------------------------- Alt health text --
function addon:CreateAltHealthText(frame, f)
	f.health.mo = f:CreateFontString(f.overlay, {
		font = self.font, size = 'small', alpha = .6, outline = "OUTLINE" })
	f.health.mo:SetJustifyH('RIGHT')
	f.health.mo:SetJustifyV('TOP')
	f.health.mo:SetHeight(10)
	f.health.mo:SetPoint('TOPRIGHT', f.health, 'BOTTOMRIGHT',
		-2.5, self.uiscale and (3.5/self.uiscale) or 3.5)
end
------------------------------------------------------------------ Level text --
function addon:CreateLevel(frame, f)
	if not f.level then return end

	f.level = f:CreateFontString(f.level, { reset = true,
		font = self.font, size = 'name', outline = 'OUTLINE' })
	f.level:SetParent(f.overlay)
	f.level:SetJustifyH('LEFT')
	f.level:SetJustifyV('BOTTOM')
	f.level:SetHeight(10)
	
	f.level:ClearAllPoints()
	f.level:SetPoint('BOTTOMLEFT', f.health, 'TOPLEFT',
		             2.5, self.uiscale and -(2.5/self.uiscale) or -2.5)
	f.level.enabled = true
end
------------------------------------------------------------------- Name text --
function addon:CreateName(frame, f)	
	f.name = f:CreateFontString(f.overlay, {
		font = self.font, size = 'name', outline = 'OUTLINE' })
	f.name:SetJustifyH('LEFT')
	f.name:SetJustifyV('BOTTOM')
	f.name:SetPoint('RIGHT', f.health.p, 'LEFT')
	f.name:SetHeight(10)

	if f.level.enabled then
		f.name:SetPoint('LEFT', f.level, 'RIGHT', -2, 0)
		f.level:Show()
	else
		f.name:SetPoint('BOTTOMLEFT', f.health, 'TOPLEFT',
		                2.5, self.uiscale and -(2.5/self.uiscale) or -2.5)
	end
end
