﻿local L = LibStub("gLocale-2.0"):NewLocale((select(1, ...)), "enUS", true) -- do NOT set the 'true' flag on any other locales!
if not L then return end

--[[
	enUS.lua
	
	This is the default locale. 
	Everything not specified in any other locale file will be retrieved from here. 
	This file should also serve as a template when translating to other locales.
	
	When the value of an entry is set to 'true', the key name will be returned instead. 
	This should only apply to the default locale, which is this one. 
	In all other locales you should put the translated text within quotation marks in place of the 'true' value, 
	and never touch the text in the key/index. 
	
	NEVER change the key/index names located between the square brackets in L["EXAMPLENAME"]
	NEVER change anything within escape sequences or search patterns, eg:
		"(|Hplayer.+|h) has earned the achievement (.+)!"
			- only "has earned the achievement" should be translated here, as the rest are links and formatting
		
		"|cFFFFD100Hello to you!|r"
			- only "Hello to you!" should be translated here, as the rest is a color code. 
			
		If you wish to learn more about escape sequences and search patterns, I recommend the following:
			http://www.wowpedia.org/UI_escape_sequences -- text codes unique to WoW
			http://www.wowpedia.org/Pattern_matching -- Lua text patterns


	I proof read all submitted locales before releasing them, though, so major errors should hopefully be avoided! 

	I can however not do anything about your bad spelling, so try to keep that to a minimum... 
	If I knew how to write in all sorts of languages, I really wouldn't be needing anybody to localize. ;)
	
	Enjoy!
]]--

-- Bags
do
	L["Gizmos"] = true -- used for "special" things like the toy train set
	L["Equipment Sets"] = true -- used for the stored equipment sets
	L["New Items"] = true -- used for the unsorted new items category in the bags
	L["Click to sort"] = true
	L["<Left-Click to toggle display of the Bag Bar>"] = true
	L["<Left-Click to open the currency frame>"] = true
	L["<Left-Click to open the category selection menu>"] = true
	L["<Left-Click to search for items in your bags>"] = true
	L["Close all your bags"] = true
	L["Close this category and keep it hidden"] = true
	L["Close this category and show its contents in the main container"] = true
end

-- Bags: menus 
do
	L["A character can store items in its backpack, bags and bank. Here you can configure the appearance and behavior of these."] = true
	L["Container Display"] = true
	L["Show this category and its contents"] = true
	L["Hide this category and all its contents completely"] = true
	L["Bypass"] = true
	L["Hide this category, and display its contents in the main container instead"] = true
	L["Choose the minimum item quality to display in this category"] = true
	L["Bag Width"] = true
	L["Sets the number of horizontal slots in the bag containers. Does not apply to the bank."] = true
	L["Bag Scale"] = true
	L["Sets the overall scale of the bags"] = true
	L["Restack"] = true
	L["Automatically restack items when opening your bags or the bank"] = true
	L["Automatically restack when looting or crafting items"] = true
	L["Sorting"] = true
	L["Sort the items within each container"] = true
	L["Sorts the items inside each container according to rarity, item level, name and quanity. Disable to have the items remain in place."] = true
	L["Compress empty bag slots"] = true
	L["Compress empty slots down to maximum one row of each type."] = true
	L["Lock the bags into place"] = true
	L["Slot Button Size"] = true
	L["Choose the size of the slot buttons in your bags."] = true
	L["Sets the size of the slot buttons in your bags. Does not affect the overall scale."] = true
	L["Bag scale"] = true
	L["Button Styling"] = true 
	L["Show gloss layer on buttons"] = true
	L["Show Gloss"] = true 
	L["This will display the gloss overlay on the buttons"] = true
	L["Show shade layer on buttons"] = true
	L["This will display the shade overlay on the buttons"] = true
	L["Show Shade"] = true 
	L["Show Durability"] = true
	L["This will display durability on damaged items in your bags"] = true
	L["Color unequippable items red"] = true
	L["This will color equippable items in your bags that you are unable to equip red"] = true
	L["Apply 'All In One' Layout"] = true
	L["Click here to automatically configure the bags and bank to be displayed as large unsorted containers."] = true
	L["The bags can be configured to work as one large 'all-in-one' container, with no categories, no sorting and no empty space compression. If you wish to have that type of layout, click the button:"] = true
	L["The 'New Items' category will display newly acquired items if enabled. Here you can set which categories and rarities to include."] = true
	L["Minimum item quality"] = true
	L["Choose the minimum item rarity to be included in the 'New Items' category."] = true
end

-- Bags: Install
do
	L["Select Layout"] = true
	L["The %s bag module has a variety of configuration options for display, layout and sorting."] = true
	L["The two most popular has proven to be %s's default layout, and the 'All In One' layout."] = true
	L["The 'All In One' layout features all your bags and bank displayed as singular large containers, with no categories, no sorting and no empty space compression. This is the layout for those that prefer to sort and control things themselves."] = true
	L["%s's layout features the opposite, with all categories split into separate containers, and sorted within those containers by rarity, item level, stack size and item name. This layout also compresses empty slots to take up less screen space."] = true
	L["You can open your bags to test out the different layouts before proceding!"] = true
	L["Apply %s's Layout"] = true
end

-- Bags: chat commands
do
	L["Empty bag slots will now be compressed"] = true
	L["Empty bag slots will no longer be compressed"] = true
end

-- Bags: restack
do
	L["Restack is already running, use |cFF4488FF/restackbags resume|r if stuck"] = true
	L["Resuming restack operation"] = true
	L["No running restack operation to resume"] = true
	L["<Left-Click to restack the items in your bags>"] = true
	L["<Left-Click to restack the items in your bags>|n<Right-Click for options>"] = true
end


--------------------------------------------------------------------------------------------------
--		Error Messages 
--------------------------------------------------------------------------------------------------
do
	L["Can't toggle Action Bars while engaged in combat!"] = true
	L["Can't change Action Bar layout while engaged in combat!"] = true
	L["Frames cannot be moved while engaged in combat"] = true
	L["Hiding movable frame anchors due to combat"] = true
	L["UnitFrames cannot be configured while engaged in combat"] = true
	L["Can't initialize bags while engaged in combat."] = true
	L["Please exit combat then re-open the bags!"] = true
end


--------------------------------------------------------------------------------------------------
--		Core Messages
--------------------------------------------------------------------------------------------------
do
	L["Can not apply default settings while engaged in combat."] = true
end

-- general 
-- basically a bunch of very common words, phrases and abbreviations
-- that several modules might have need for
do
	L["Always"] = true
	L["Apply"] = true
	L["Bags"] = true
	L["Bank"] = true 
	L["Bottom"] = true
	L["Cancel"] = true
	L["Categories"] = true
	L["Close"] = true
	L["Continue"] = true
	L["Copy"] = true -- to copy. the verb.
	L["Default"] = true
	L["Elements"] = true -- like elements in a frame, not as in fire, ice etc
	L["Free"] = true -- free space in bags and bank
	L["General"] = true -- general as in general info
	L["Ghost"] = true -- when you are dead and have released your spirit
	L["Hide"] = true -- to hide something. not hide as in "thick hide".
	L["Lock"] = true -- to lock something, like a frame. the verb.
	L["Main"] = true -- used for Main chat frame, Main bag, etc
	L["Next"] = true
	L["Never"] = true
	L["No"] = true
	L["Okay"] = true
	L["Open"] = true
	L["Paste"] = true -- as in copy & paste. the verb.
	L["Reset"] = true
	L["Rested"] = true -- when you are rested, and will recieve 200% xp from kills
	L["Scroll"] = true -- "Scroll" as in "Scroll of Enchant". The noun, not the verb.
	L["Show"] = true
	L["Skip"] = true
	L["Top"] = true
	L["Total"] = true
	L["Visibility"] = true
	L["Yes"] = true
end

-- visible module names
do
	L["Bags"] = true
end
