﻿local addon, ns = ...
local L

-- enUS
L = {
	------------------------------------------------------------
	--		GUI Options
	------------------------------------------------------------
	["TITLE"] 									= "|cFFFF7D0Ag|r|cFFFFBB00Chat|r";
	["GUI_OPTIONS"] 							= "Options";
	["GUI_OPTIONS_DESCRIPTION"] 				= "";
	["GUI_RESET_ALL"] 							= "Reset";
	["GUI_RESET_ALL_DESCRIPTION"] 				= "Resets all of the settings back to the default values.";

	["GUI_CHAT_MOVEEDITBOX"] 					= "Move inputbox to the top of the chatframe";

	["GUI_CHAT_SHOWCLUTTER"] 					= "Show the scrollarrows and the menubutton";
	["GUI_CHAT_SHOWBOTTOMBUTTON"] 				= "Only and always show the bottom button when NOT being at the bottom of the chat.";

	["GUI_CHAT_ENABLEMOUSE"] 					= "Enable use of the mouse wheel to scroll";
	["GUI_CHAT_ENABLEARROWS"] 					= "Enable use of the arrow keys in the inputbox";
	["GUI_CHAT_FADE"] 							= "Fades the chat out after a period of inactivity. Uncheck for the chat to remain visible.";

	["GUI_CLUTTER_SCRPOS"] 						= "Set the position of the clutter relative to the screen:";
	["GUI_CLUTTER_SCRPOS_CENTER"] 				= "Close to the center";
	["GUI_CLUTTER_SCRPOS_EDGE"] 				= "Close to the edges";
	["GUI_CLUTTER_SCRPOS_RIGHT"] 				= "Always on the right";
	["GUI_CLUTTER_SCRPOS_LEFT"] 				= "Always on the left";
	["GUI_CLUTTER_SCRPOS_OPTION_CENTER"] 		= "Center";
	["GUI_CLUTTER_SCRPOS_OPTION_EDGE"] 			= "Edges";
	["GUI_CLUTTER_SCRPOS_OPTION_RIGHT"] 		= "Right";
	["GUI_CLUTTER_SCRPOS_OPTION_LEFT"] 			= "Left";

	["GUI_CLUTTER_POSITION"] 					= "Set the position of the clutter relative to the chatframes:";
	["GUI_CLUTTER_POSITION_OUTSIDE"] 			= "Outside the chatframe";
	["GUI_CLUTTER_POSITION_INSIDE"] 			= "Inside the chatframe";
	["GUI_CLUTTER_POSITION_OPTION_OUTSIDE"] 	= "Outside";
	["GUI_CLUTTER_POSITION_OPTION_INSIDE"] 		= "Inside";

	["GUI_CLUTTER_VISIBILITY"] 					= "Set the visibility of the clutter:";
	["GUI_CLUTTER_VISIBILITY_HIDDEN"] 			= "Always hidden";
	["GUI_CLUTTER_VISIBILITY_HIDDEN2"] 			= "Always hidden, but with visible bottombutton";
	["GUI_CLUTTER_VISIBILITY_VISIBLE"] 			= "Always visible";
	["GUI_CLUTTER_VISIBILITY_HOVER"] 			= "Show on hover";
	["GUI_CLUTTER_VISIBILITY_OPTION_HIDDEN"] 	= "Always hidden";
	["GUI_CLUTTER_VISIBILITY_OPTION_HIDDEN2"] 	= "Hidden + Bottom";
	["GUI_CLUTTER_VISIBILITY_OPTION_VISIBLE"] 	= "Always visible";
	["GUI_CLUTTER_VISIBILITY_OPTION_HOVER"] 	= "Hover";

	["GUI_EDITBOX_MODE"] 						= "Set the inputbox background:";
	["GUI_EDITBOX_MODE_HIDDEN"] 				= "Always hidden";
	["GUI_EDITBOX_MODE_BLIZZARD"] 				= "Always visible";
	["GUI_EDITBOX_MODE_NEON"] 					= "Clean style";
	["GUI_EDITBOX_MODE_OPTION_HIDDEN"] 			= "Always hidden";
	["GUI_EDITBOX_MODE_OPTION_BLIZZARD"] 		= "Always visible";
	["GUI_EDITBOX_MODE_OPTION_NEON"] 			= "Clean style";
	
	["GUI_TAB_STYLE"] 							= "Set the style of the ChatTabs:";
	["GUI_TAB_STYLE_BLIZZARD"] 					= "Default";
	["GUI_TAB_STYLE_CLEAN"] 					= "Clean style";
	["GUI_TAB_STYLE_OPTION_BLIZZARD"] 			= "Default";
	["GUI_TAB_STYLE_OPTION_CLEAN"] 				= "Clean style";
	
	["GUI_SHORTS"] 								= "Abbreviate chat?";
	["GUI_SHORTS_NONE"] 						= "No abbreviations";
	["GUI_SHORTS_CHAN"] 						= "Abbreviate the chat";
	["GUI_SHORTS_CHANPLAY"] 					= "Abbreviate the chat, and remove the brackets";
	["GUI_SHORTS_OPTION_NONE"] 					= "None";
	["GUI_SHORTS_OPTION_CHAN"] 					= "Yes";
	["GUI_SHORTS_OPTION_CHANPLAY"] 				= "Yes + Brackets";
	
	["GUI_FONT"] 								= "Set the font shadow- and outline: ";
	["GUI_FONT_NONE"] 							= "Normal chat";
	["GUI_FONT_OUTLINE"] 						= "Outlined chat";
	["GUI_FONT_SHADOW"] 						= "Outlined chat plus a bigger shadow";
	["GUI_FONT_OPTION_NONE"] 					= "Normal";
	["GUI_FONT_OPTION_OUTLINE"] 				= "Outline";
	["GUI_FONT_OPTION_SHADOW"] 					= "Outline + Shadow";
	
	------------------------------------------------------------
	--		Abbreviations
	------------------------------------------------------------
	-- lots of abbreviations by replacing the globals. 
	["ABBREVIATIONS"] = {
		-- set flags
		CHAT_FLAG_AFK 							= "[AFK]\32";
		CHAT_FLAG_DND 							= "[DND]\32";
		CHAT_FLAG_GM 							= "[GM]\32";
		CHAT_AFK_GET 							= "%s [AFK]:\32";

		-- activity
		CLEARED_AFK 							= "-[AFK]";
		CLEARED_DND 							= "-[DND]";
		MARKED_AFK 								= "+[AFK}";
		MARKED_AFK_MESSAGE 						= "+[AFK]: %s";
		MARKED_DND 								= "+[DND]: %s.";

		-- channel traffic
		CHAT_CHANNEL_JOIN_GET 					= "+ %s";
		CHAT_CHANNEL_LEAVE_GET 					= "- %s";
		CHAT_YOU_CHANGED_NOTICE 				= "# |Hchannel:%d|h[%s]|h";
		CHAT_YOU_JOINED_NOTICE 					= "+ |Hchannel:%d|h[%s]|h";
		CHAT_YOU_LEFT_NOTICE 					= "- |Hchannel:%d|h[%s]|h";

		-- friends
		ERR_FRIEND_OFFLINE_S 					= "- %s";
		ERR_FRIEND_ONLINE_SS 					= "+ |Hplayer:%s|h[%s]|h";
		
		-- abbreviate channels
		CHAT_GUILD_GET 							= "|Hchannel:Guild|h[G]|h %s:\32";
		CHAT_OFFICER_GET 						= "|Hchannel:o|h[O]|h %s:\32";

		CHAT_BATTLEGROUND_GET 					= "|Hchannel:Battleground|h[BG]|h %s:\32";
		CHAT_BATTLEGROUND_LEADER_GET 			= "|Hchannel:Battleground|h[BGL]|h %s:\32";

		CHAT_PARTY_GET 							= "|Hchannel:Party|h[P]|h %s:\32";
		CHAT_PARTY_GUIDE_GET 					= "|Hchannel:party|h[DG]|h %s:\32";
		CHAT_PARTY_LEADER_GET 					= "|Hchannel:party|h[PL]|h %s:\32";
		CHAT_RAID_GET 							= "|Hchannel:raid|h[R]|h %s:\32";
		CHAT_RAID_LEADER_GET 					= "|Hchannel:raid|h[RL]|h %s:\32";
		CHAT_RAID_WARNING_GET 					= "[RW] %s:\32";

		CHAT_SAY_GET 							= "%s:\32";
		CHAT_WHISPER_GET 						= "%s:\32";
		CHAT_WHISPER_INFORM_GET 				= ">%s:\32";
		CHAT_YELL_GET 							= "%s:\32";

		-- Battle.net
		CHAT_BN_WHISPER_GET 					= "%s:\32";
		CHAT_BN_WHISPER_INFORM_GET 				= ">%s:\32";
		CHAT_BN_WHISPER_SEND 					= "%s:\32"; -- this might very well be bugged in wow
		CHAT_BN_CONVERSATION_GET 				= "%s:\32";
		CHAT_BN_CONVERSATION_GET_LINK 			= "|Hchannel:BN_CONVERSATION:%d|h[%s]|h";
		CHAT_BN_CONVERSATION_SEND 				= "[%d]:";

		-- creature messages
		CHAT_MONSTER_PARTY_GET 					= "|Hchannel:Party|h[P]|h %s:\32";
		CHAT_MONSTER_SAY_GET 					= "%s:\32";
		CHAT_MONSTER_WHISPER_GET 				= "%s:\32";
		CHAT_MONSTER_YELL_GET 					= "%s:\32";

		-- achievement messages
		ACHIEVEMENT_BROADCAST 					= "%s! %s!";
		ACHIEVEMENT_BROADCAST_SELF 				= "%s!";
		PLAYER_SERVER_FIRST_ACHIEVEMENT 		= "|Hplayer:%s|h[%s]|h! $a!";
		SERVER_FIRST_ACHIEVEMENT 				= "%s! $a!";
		
		-- PvP related
		COMBATLOG_HONORAWARD 					= "+%.2f "..COMBAT_HONOR_GAIN;
		COMBATLOG_HONORGAIN 					= "%s, HK: %s +%.2f "..COMBAT_HONOR_GAIN;
		COMBATLOG_HONORGAIN_NO_RANK 			= "%s, +%.2f "..COMBAT_HONOR_GAIN;
		
		-- loot
		LOOT_ITEM 								= "%s: +%s";
		LOOT_ITEM_CREATED_SELF 					= "+%s";
		LOOT_ITEM_CREATED_SELF_MULTIPLE 		= "+%sx%d";
		LOOT_ITEM_MULTIPLE 						= "%s: +%sx%d";
		LOOT_ITEM_PUSHED_SELF 					= "+%s";
		LOOT_ITEM_PUSHED_SELF_MULTIPLE 			= "+%sx%d";
		LOOT_ITEM_SELF 							= "+%s";
		LOOT_ITEM_SELF_MULTIPLE 				= "+%sx%d";
		YOU_RECEIVED 							= "+";
		YOU_LOOT_MONEY 							= "+%s";
		LOOT_MONEY 								= "%s: +%s";
		LOOT_MONEY_SPLIT 						= "+%s";
		LOOT_MONEY_SPLIT_GUILD 					= "+%s (+%s "..GUILD_BANK..")";
		LOOT_ROLL_YOU_WON 						= "> %s!";
		LOOT_ROLL_WON 							= "%s > %s!";

		-- quest rewards xp/loot
		ERR_QUEST_REWARD_EXP_I 					= "+%d XP";
		ERR_QUEST_REWARD_ITEM_MULT_IS 			= "+%dx%s";
		ERR_QUEST_REWARD_ITEM_S 				= "+%s";
		ERR_QUEST_REWARD_MONEY_S 				= "+%s";

		-- experience
		COMBATLOG_XPGAIN_EXHAUSTION1 				= "%s: +%d XP (%s XP %s)";
		COMBATLOG_XPGAIN_EXHAUSTION1_GROUP 			= "%s: +%d XP (%s XP %s, +%d)";
		COMBATLOG_XPGAIN_EXHAUSTION1_RAID 			= "%s: +%d XP (%s XP %s, -%d)";
		COMBATLOG_XPGAIN_EXHAUSTION2 				= "%s: +%d XP (%s XP %s)";
		COMBATLOG_XPGAIN_EXHAUSTION2_GROUP 			= "%s: +%d XP (%s XP %s, +%d)";
		COMBATLOG_XPGAIN_EXHAUSTION2_RAID 			= "%s: +%d XP (%s XP %s, -%d)";
		COMBATLOG_XPGAIN_EXHAUSTION4 				= "%s: +%d XP (%s XP %s)";
		COMBATLOG_XPGAIN_EXHAUSTION4_GROUP 			= "%s: +%d XP (%s XP %s, +%d)";
		COMBATLOG_XPGAIN_EXHAUSTION4_RAID 			= "%s: +%d XP (%s XP %s, -%d)";
		COMBATLOG_XPGAIN_EXHAUSTION5 				= "%s: +%d XP (%s XP %s)";
		COMBATLOG_XPGAIN_EXHAUSTION5_GROUP 			= "%s: +%d XP (%s XP %s, +%d)";
		COMBATLOG_XPGAIN_EXHAUSTION5_RAID 			= "%s: +%d XP (%s XP %s, -%d)";
		COMBATLOG_XPGAIN_FIRSTPERSON 				= "%s: +%d XP";
		COMBATLOG_XPGAIN_FIRSTPERSON_GROUP 			= "%s: +%d XP (%d)";
		COMBATLOG_XPGAIN_FIRSTPERSON_RAID 			= "%s: +%d XP (%d)";
		COMBATLOG_XPGAIN_FIRSTPERSON_UNNAMED 		= "+%d XP";
		COMBATLOG_XPGAIN_FIRSTPERSON_UNNAMED_GROUP 	= "+%d XP (%d)";
		COMBATLOG_XPGAIN_FIRSTPERSON_UNNAMED_RAID 	= "+%d XP (%d)";
		COMBATLOG_XPGAIN_QUEST 						= "+%d XP (%s XP %s)";
		COMBATLOG_XPLOSS_FIRSTPERSON_UNNAMED 		= "-%d XP";

		-- reputation
		FACTION_STANDING_DECREASED 					= "%s: -%d Reputation";
		FACTION_STANDING_INCREASED 					= "%s: +%d Reputation";
		FACTION_STANDING_INCREASED_BONUS 			= "%s: +%d Reputation (+%.1f Refer-A-Friend bonus)";
		
		-- skills
		ERR_SKILL_UP_SI 							= "%s: %d";
		
	};

	-- more abbreviations 
	["FULL_ACHIEVEMENT_GAINED"] 				= "(|Hplayer.+|h) has earned the achievement (.+)!"; 
	["SHORT_ACHIEVEMENT_GAINED"] 				= "%1 ! %2"; 
	
	
	------------------------------------------------------------
	--		Keybinds
	------------------------------------------------------------
	["KEYBIND_WHISPER_TARGET"] 					= "Whisper target";
	["KEYBIND_WHISPER_FOCUS"] 					= "Whisper focus";

}
gLib:AddLocale( addon, nil, L )

-- deDE
L = {
	["FULL_ACHIEVEMENT_GAINED"] 			= "(|Hplayer.+|h) hat den Erfolg (.+) errungen!"; 
}
gLib:AddLocale( addon, "deDE", L )

